// get thunder path
function getThunderPath()
{
	var strThunderPath = regReadString("Software\\Thunder Network\\ThunderOem\\thunder_backwnd", "Path");
	return strThunderPath;
}

function ThunderComponent(){
	Components.utils.import('resource://gre/modules/ctypes.jsm');
	
	var thunderComponentDll;
	var CallThunder;
	var WhetherDynamicLink;
	var LoadProfile;
	var ShowFloatBar;
	var HideFloatBar;

  this.LoadDll = function() {
	var profFile = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("ProfD", Components.interfaces.nsIFile);
	
	var profPath = profFile.path;
	var strDllPath = profPath.concat('\\extensions\\{1B33E42F-EF14-4cd3-B6DC-174571C4349C}\\components\\ThunderComponent.dll');
	thunderComponentDll = ctypes.open(strDllPath);

	CallThunder = thunderComponentDll.declare('CallThunder', 
												ctypes.winapi_abi, ctypes.int, 
												ctypes.jschar.ptr, ctypes.jschar.ptr, 
												ctypes.uint32_t, ctypes.uint32_t, 
												ctypes.uint32_t.ptr);
	
    WhetherDynamicLink = thunderComponentDll.declare('WhetherDynamicLink', 
														ctypes.winapi_abi, ctypes.int, 
														ctypes.jschar.ptr, ctypes.uint32_t.ptr);
											
	LoadProfile = thunderComponentDll.declare('LoadProfile', 
												ctypes.winapi_abi, ctypes.int, 
												ctypes.jschar.ptr);
	
	ShowFloatBar = thunderComponentDll.declare('ShowFloatBar', 
												ctypes.winapi_abi, ctypes.int, 
												ctypes.jschar.ptr, ctypes.jschar.ptr);
	
	HideFloatBar = thunderComponentDll.declare('HideFloatBar', 
												ctypes.winapi_abi, ctypes.int);
  }

  this.UnLoadDll = function() {
    thunderComponentDll.close();
  }

  this.CallThunder = function(strUrls, strAsync,bMonitor,bAll) {
    var nResult = new ctypes.uint32_t;
	var hr = CallThunder(strUrls, strAsync, bMonitor, bAll, nResult.address());
	return nResult.address().contents;
  }
  
  this.WhetherDynamicLink = function(strUrls) {
    var nResult = new ctypes.uint32_t;
	var hr = WhetherDynamicLink(strUrls, nResult.address());
	return nResult.address().contents;
  }
  
  this.LoadProfile = function() {
	var buf = new new ctypes.ArrayType(ctypes.jschar, 255);
	var hr = LoadProfile(buf);
	var strConfigPath = buf.readString();
	return strConfigPath;
  }
  
  this.ShowFloatBar = function(strDocumentUrl, strOuterHTML) {
	var hr = ShowFloatBar(strDocumentUrl, strOuterHTML);
	return hr;
  }
  
  this.HideFloatBar = function() {
	var hr = HideFloatBar();
	return hr;
  }
}


// create thunder component
/*
function createThunderComponent()
{
     if (g_thunderComponent == null)
	{
		try
		{
			g_thunderComponent = Components.classes["@thunder.com/thundercomponent;1"].createInstance();
			g_thunderComponent = g_thunderComponent.QueryInterface(Components.interfaces.IThunderComponent);
		}
		catch(err)
		{
			alert(err);
			return;
		}
	}
}
*/

